unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Button3: TButton;
    Edit1: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Button8: TButton;
    Button9: TButton;
    Edit4: TEdit;
    Button12: TButton;
    Button13: TButton;
    Edit7: TEdit;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Edit8: TEdit;
    ComboBox5: TComboBox;
    Button15: TButton;
    ComboBox6: TComboBox;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    ComboBox7: TComboBox;
    Edit9: TEdit;
    Button14: TButton;
    Button19: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Label15: TLabel;
    Label1: TLabel;
    Panel3: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Panel4: TPanel;
    Label3: TLabel;
    Label6: TLabel;
    Label14: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label13: TLabel;
    Panel5: TPanel;
    Panel6: TPanel;
    Label2: TLabel;
    Label4: TLabel;
    Panel7: TPanel;
    Panel8: TPanel;
    Label7: TLabel;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);

    
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TelegramBit : integer;
  Comport : integer;
  Baudrate : dword;


implementation

{$R *.dfm}
{$I  DSE.inc}       //DSE.DLL inkluderes


procedure TForm1.Button1Click(Sender: TObject);
begin
  if Combobox2.text='38400' then Baudrate:=38400;
  if Combobox2.text='115200' then Baudrate:=115200;
  if Combobox2.text='230400' then Baudrate:=230400;
  if Combobox2.text='460800' then Baudrate:=460800;
  if Combobox2.text='921600' then Baudrate:=921600;

  if RadioButton1.checked=true then TelegramBit:=16 else TelegramBit:=18;

  if Combobox1.text='1' then Comport:=1;
  if Combobox1.text='2' then Comport:=2;
  if Combobox1.text='3' then Comport:=3;
  if Combobox1.text='4' then Comport:=4;
  if Combobox1.text='5' then Comport:=5;
  if Combobox1.text='6' then Comport:=6;
  if Combobox1.text='7' then Comport:=7;
  if Combobox1.text='8' then Comport:=8;
  if Combobox1.text='9' then Comport:=9;
  if Combobox1.text='10' then Comport:=10;

  DSE_Open(Comport, Baudrate, TelegramBit);
  DSE_StartQueue;
end;


procedure TForm1.Button2Click(Sender: TObject);
var
  Value : Integer;
  XString : String[8];

begin
  Value:=DSE_PeekValue;
  XString:=IntToStr(Value);
  Edit1.Text:=XString;
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
  Combobox1.text:='1';
  Combobox2.text:='38400';
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
  DSE_StopQueue;
  DSE_Close;
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
  DSE_StartQueue;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
  DSE_StopQueue;
end;


procedure TForm1.Button7Click(Sender: TObject);
var
  Value : Integer;
  XString : String[8];

begin
  Value:=DSE_PopQueue;
  XString:=IntToStr(Value);
  Edit2.Text:=XString;
end;


procedure TForm1.Button6Click(Sender: TObject);
var
  Value : Integer;
  XString : String[8];

begin
  Value:=DSE_QueueSize;
  XString:=IntToStr(Value);
  Edit3.Text:=XString;
end;


procedure TForm1.Button8Click(Sender: TObject);
begin
  DSE_ClearQueue;
end;
          

procedure TForm1.Button9Click(Sender: TObject);
var
  Value : Integer;
  XString : String[8];

begin
  Value:=DSE_PopQueue;
  XString:=IntToStr(Value);
  Edit4.Text:=XString;
end;


procedure TForm1.Button12Click(Sender: TObject);
begin
  DSESEL_Check;
end;


procedure TForm1.Button13Click(Sender: TObject);
var
  ParNum : integer;
  Value : integer;        
  XString : String[8];

begin
  if Combobox3.text='DSE_PAR_GRPSIZE (1)' then ParNum:=1;
  if Combobox3.text='DSE_PAR_GRPZERO (2)' then ParNum:=2;
  if Combobox3.text='DSE_PAR_COMRATE (3)' then ParNum:=3;
  if Combobox3.text='DSE_PAR_MEDSIZE (4)' then ParNum:=4;
  if Combobox3.text='DSE_PAR_AVGSIZE (5)' then ParNum:=5;

  Value:=DSESEL_GetPar(ParNum);
  XString:=intToStr(Value);
  Edit7.Text:=XString;
end;


procedure TForm1.Button15Click(Sender: TObject);
var
  BitMask : Integer;
  Value : Integer;

begin
  if Combobox5.text='DSE_BIT_EXTMODE (0)' then BitMask:=0;
  if Combobox5.text='DSE_BIT_LVLMODE (1)' then BitMask:=1;
  if Combobox5.text='DSE_BIT_ERRMODE (2)' then BitMask:=2;
  if Combobox5.text='DSE_BIT_SAMMODE (3)' then BitMask:=3;
  if Combobox5.text='DSE_BIT_DIFMODE (4)' then BitMask:=4;
  if Combobox5.text='DSE_BIT_RECMODE (5)' then BitMask:=5;

  if Combobox6.Text='True' then Value:=1 else Value:=0;

  DSESEL_SetBit(BitMask, Value);
end;


procedure TForm1.Button16Click(Sender: TObject);
var
  ParNum : integer;
  Value : integer;
  ValueString : String[10];

begin
  if Combobox4.text='DSE_PAR_RUNSIZE (1)' then ParNum:=1;
  if Combobox4.text='DSE_PAR_RUNZERO (2)' then ParNum:=2;
  if Combobox4.text='DSE_PAR_COMRATE (3)' then ParNum:=3;
  if Combobox4.text='DSE_PAR_MEDSIZE (4)' then ParNum:=4;
  if Combobox4.text='DSE_PAR_AVGSIZE (5)' then ParNum:=5;

  ValueString:=Edit8.Text;
  Value:=StrToInt(ValueString);

  DSESEL_SetPar(ParNum, Value);
end;


procedure TForm1.Button17Click(Sender: TObject);
begin
  DSESEL_Select(false,false);
end;


procedure TForm1.Button18Click(Sender: TObject);
var
  BitMask : Integer;
  Value : Integer;
  XString : String[8];

begin
  if Combobox7.text='DSE_BIT_EXTMODE (0)' then BitMask:=0;
  if Combobox7.text='DSE_BIT_LVLMODE (1)' then BitMask:=1;
  if Combobox7.text='DSE_BIT_ERRMODE (2)' then BitMask:=2;
  if Combobox7.text='DSE_BIT_SAMMODE (3)' then BitMask:=3;
  if Combobox7.text='DSE_BIT_DIFMODE (4)' then BitMask:=4;
  if Combobox7.text='DSE_BIT_RECMODE (5)' then BitMask:=5;

  Value:=DSESEL_GetBit(BitMask);
  XString:=IntToStr(Value);
  Edit9.Text:=XString;
end;


procedure TForm1.Button14Click(Sender: TObject);
var
  x : Integer;
  
begin
  x:=DSE_Status(false);

  if (x AND 1)=1 then Checkbox1.Checked:=true else Checkbox1.Checked:=false;
  if (x AND 2)=2 then Checkbox2.Checked:=true else Checkbox2.Checked:=false;
  if (x AND 4)=4 then Checkbox3.Checked:=true else Checkbox3.Checked:=false;
  if (x AND 8)=8 then Checkbox4.Checked:=true else Checkbox4.Checked:=false;
  if (x AND 16)=16 then Checkbox5.Checked:=true else Checkbox5.Checked:=false;

  if (x AND 128)=128 then Checkbox6.Checked:=true else Checkbox6.Checked:=false;
  if (x AND 256)=256 then Checkbox7.Checked:=true else Checkbox7.Checked:=false;
end;


procedure TForm1.Button19Click(Sender: TObject);
var
  x : Integer;

begin
  x:=DSE_Status(true);
  if (x AND 1)=1 then Checkbox1.Checked:=true else Checkbox1.Checked:=false;
  if (x AND 2)=2 then Checkbox2.Checked:=true else Checkbox2.Checked:=false;
  if (x AND 4)=4 then Checkbox3.Checked:=true else Checkbox3.Checked:=false;
  if (x AND 8)=8 then Checkbox4.Checked:=true else Checkbox4.Checked:=false;
  if (x AND 16)=16 then Checkbox5.Checked:=true else Checkbox5.Checked:=false;

  if (x AND 128)=128 then Checkbox6.Checked:=true else Checkbox6.Checked:=false;
  if (x AND 256)=256 then Checkbox7.Checked:=true else Checkbox7.Checked:=false;
end;


end.
